package it.unina.instrumented.korel.comp;

public class CompareSums {
	private Integer numTestRequirements = 3;
	private Double[] korelValues = new Double[2 * numTestRequirements];
	private Boolean[] isReached = new Boolean[numTestRequirements];

	public Double[] getKorelValues() {
		return korelValues;
	}
	
	public Boolean[] getIsReached() {
		return isReached;
	}
	
	public String compareSums(Integer i, Integer j, Integer k) {
		String resp = "";
		double diff = sommatoria(Math.abs(i));
		double dk = new Double(k) * new Double(j);

		korelValues[0] = KorelFunction.korelFunction(diff, dk,
				KorelFunction.GREATER_THEN_OP);
		korelValues[1] = KorelFunction.korelFunction(diff, dk,
				KorelFunction.LESS_EQUAL_OP);
		
		if ((isReached[0]=(diff > dk)) && (diff > dk) )
			resp = "diff > k";

		korelValues[2] = KorelFunction.korelFunction(diff, dk,
				KorelFunction.EQUAL_OP);
		korelValues[3] = KorelFunction.korelFunction(diff, dk,
				KorelFunction.NOT_EQUAL_OP);
		
		if ((isReached[1]=(diff == dk)) && (diff == dk)) 
			resp = "diff == k";
		
		korelValues[4] = KorelFunction.korelFunction(diff, dk,
				KorelFunction.LESS_THEN_OP);
		korelValues[5] = KorelFunction.korelFunction(diff, dk,
				KorelFunction.GREATER_EQUAL_OP);
		
		if ((isReached[2]=(diff < dk)) && (diff < dk))
			resp = "diff < k";
	
		return resp;
	}

	public Double sommatoria(Integer n) {
		Double ris = 0d;
		if (n < 0) return ris;

		ris = 1d;
		if (n > 1) {
			for (int i = 2; i <= n; i++)
				ris = ris + i;
		}

		return ris;
	}

}
